var egs;
(function (egs) {
    var scripts;
    (function (scripts) {
        var AnimationScript = (function (_super) {
            __extends(AnimationScript, _super);
            function AnimationScript(body) {
                if (body === void 0) { body = null; }
                _super.call(this);
                this._frames = new egs.Dictionary();
                this.Distance = 0;
                this.Loop = false;
                this.CurrentAniName = null;
                this._frameindex = 0;
                this._isPaused = false;
                this._frametimer = 0;
                this.Body = body;
            }
            var d = __define,c=AnimationScript,p=c.prototype;
            p.Play = function (aniname, distance, loop) {
                if (aniname === void 0) { aniname = null; }
                if (distance === void 0) { distance = -1; }
                if (loop === void 0) { loop = true; }
                if (distance >= 0) {
                    this.Distance = distance;
                }
                if (this.CurrentAniName == aniname && !this._isPaused && loop) {
                    return;
                }
                if (aniname != null) {
                    this.CurrentAniName = aniname;
                    this.Loop = loop;
                }
                this._frameindex = 0;
                this._isPaused = false;
                return this;
            };
            p.Puase = function () {
                this._isPaused = true;
            };
            p.AddAnimat = function (aniname, ani) {
                if (this._frames.containsKey(aniname)) {
                    this._frames.remove(aniname);
                }
                this._frames.add(aniname, ani);
            };
            p.setAnimatFrameChangeEvent = function (frameChange, thisobj) {
                this._frameChange = frameChange;
                this._callthisObj = thisobj;
            };
            p.onAnimatFrameChange = function (frameindex, max) {
            };
            p.getCurrentFrames = function () {
                return this._frames.get(this.CurrentAniName);
            };
            p.onUpdate = function (dt) {
                if (this.CurrentAniName == null || this._isPaused) {
                    return;
                }
                var frames = this._frames.get(this.CurrentAniName);
                if (frames == null) {
                    return;
                }
                this._frametimer += dt;
                if (this._frametimer >= this.Distance / frames.length) {
                    this._frametimer = 0;
                    this._frameindex += 1;
                    this.onAnimatFrameChange(this._frameindex, frames.length);
                    if (this._frameChange != null) {
                        this._frameChange.call(this._callthisObj, this._frameindex, frames.length, this.CurrentAniName);
                    }
                    if (this.Loop) {
                        this._frameindex = this._frameindex % frames.length;
                    }
                    else {
                        if (this._frameindex >= frames.length) {
                            this._frameindex = frames.length - 1;
                        }
                    }
                    if (this.Body != null) {
                        if (this.Body instanceof eui.Image) {
                            this.Body.source = frames[this._frameindex];
                        }
                        else {
                            this.Body.texture = frames[this._frameindex];
                        }
                    }
                    else {
                        if (this.Owner != null) {
                            if (this.Owner instanceof eui.Image) {
                                this.Owner.source = frames[this._frameindex];
                            }
                            else {
                                if (this.Owner instanceof egret.Bitmap) {
                                    this.Owner.texture = frames[this._frameindex];
                                }
                            }
                        }
                    }
                }
            };
            return AnimationScript;
        }(egs.Behaviour));
        scripts.AnimationScript = AnimationScript;
        egret.registerClass(AnimationScript,'egs.scripts.AnimationScript');
    })(scripts = egs.scripts || (egs.scripts = {}));
})(egs || (egs = {}));
